.586
.model flat,stdcall
option casemap:none

   include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   include gdiplus.inc
   include gdiplus_structs.inc
   includelib gdiplus.lib

  includelib GDI32.LIB
  includelib user32.lib
  includelib kernel32.lib


WinMain proto :DWORD,:DWORD,:DWORD,:DWORD

LVS_EX_GRIDLINES EQU 000000001h
LVS_EX_SUBITEMIMAGES EQU 000000002h
LVS_EX_FULLROWSELECT EQU 000000020h 
LVS_EX_HEADERDRAGDROP EQU 000000010h
LVM_SETEXTENDEDLISTVIEWSTYLE EQU (LVM_FIRST + 54)
HIMETRICINCH EQU 9ECh

.data
   ClassName db "MainWinClass",0
   AppName  db "GDI+ Image Resize",0
   StaticClass db "Static",0
   NombreArchivo db "Arenalv.JPG",0 
   ImageTitle db "Arenal Volcano 3-Mar-05 (La Fortuna, San Carlos, Costa Rica)",0
   
.data?
   hInstance HINSTANCE ?
   CommandLine LPSTR ?
   hBitmap dd ?
   hImageTestL dd ?
   gdiplSTI GdiplusStartupInput <>
   token  dd ?
   NombreW db 255 dup (?)
   grafico dd ?
   imagen1 dd ?
   imagen2 dd ?
   lFormat dd ?
   sngWidth dd ?
   sngHeight dd ?
   RGB macro red,green,blue
        xor eax,eax
        mov ah,blue
        shl eax,8
        mov ah,green
        mov al,red
endm
      
.code

; ---------------------------------------------------------------------------

start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
    
;   Fill GdiplusStartupInput structure with Zeros
    invoke  RtlZeroMemory, addr gdiplSTI, sizeof GdiplusStartupInput
;   Initialize GDI+ Libreri
    mov     gdiplSTI.GdiplusVersion, 1
    push    NULL
    lea     eax, gdiplSTI
    push    eax
    lea     eax, token
    push    eax
    call    GdiplusStartup

	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL W:DWORD
LOCAL H:DWORD
LOCAL HorRes:DWORD
LOCAL VerRes:DWORD

   	.IF uMsg==WM_DESTROY
        invoke DeleteObject,hBitmap
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE

     INVOKE     CreateWindowEx,WS_EX_CLIENTEDGE,addr StaticClass,addr ImageTitle,WS_CHILD or WS_VISIBLE,\
                10, 0, 400,50, hWnd, NULL, hInstance, NULL
; Create VB Picture box to draw imagen later On
     INVOKE     CreateWindowEx,WS_EX_CLIENTEDGE,addr StaticClass, NULL,SS_BITMAP or WS_CHILD or WS_VISIBLE,\
                10, 50, 350,350, hWnd, NULL, hInstance, NULL
; Save Control handle for later use    
    mov hImageTestL,eax
; Convert Image Filename to Wide character other wise it will return error 
    invoke MultiByteToWideChar,CP_OEMCP,MB_PRECOMPOSED,addr NombreArchivo,-1,addr NombreW,255
; Load image from file and save bitmap to imagen1
    invoke GdipLoadImageFromFile,ADDR NombreW,ADDR imagen1
; Get original image pixel format (usually 32 Bit color) and save it to lFormat    
    invoke GdipGetImagePixelFormat,imagen1,addr lFormat  
; Get original image Width and save it to sngWidth
    invoke GdipGetImageWidth,imagen1,addr sngWidth
; Get original image Height and save it to sngHeight    
    invoke GdipGetImageHeight,imagen1,addr sngHeight
; Set W variable to 400 (pixels) this would be new picture width
    mov W,400
; Set H variable to 400 (pixels) this would be new picture height
    mov H,400
; C++ Bitmap::Bitmap(width, height, format) Create new bitmap with widht and height just set and same pixel format as the original image and save it to imagen2
    invoke GdipCreateBitmapFromScan0,W,H,0,lFormat,0,addr imagen2
; Set graphic interpolation mode to high quality output
;   Shrink the image using low-quality interpolation.(InterpolationModeNearestNeighbor)
;   Shrink the image using medium-quality interpolation. (InterpolationModeHighQualityBilinear)
;   Shrink the image using high-quality interpolation. (InterpolationModeHighQualityBicubic)
    invoke GdipSetInterpolationMode,grafico,InterpolationModeHighQualityBilinear  ; equ	6
; Get original image Horizontal resolution and save it to HorRes variable
    invoke GdipGetImageHorizontalResolution,imagen1,addr HorRes
; Get original image Vertical resolution and save it to VerRes variable
    invoke GdipGetImageVerticalResolution,imagen1,addr VerRes
; Set new image vertical and horizontal resolution to match orignal image resolution
    invoke GdipBitmapSetResolution,imagen2,HorRes,VerRes
; Create new graphics object from new image
    invoke GdipGetImageGraphicsContext,imagen2,addr grafico
;    RGB 0,0,0
; Set image background to Black color
    invoke GdipGraphicsClear,grafico,0
; Draw resized original image to graphic object of new bitmap
    invoke GdipDrawImageRectI,grafico,imagen1,0,0,W,H
; Destroy orignal image
    invoke GdipDisposeImage,imagen1
; Delete new image graphic object    
    invoke GdipDeleteGraphics,grafico
; Create standard GDI Bitmap from Gdi+ Bitmap and save bitmap handle in hBitmap variable     
; If you want to rotate image use: 
;invoke GdipImageRotateFlip,imagen2,Rotate90FlipNone
    invoke GdipCreateHBITMAPFromBitmap,imagen2,addr hBitmap,0
; Set VB Picture box control image to our new resized image
    invoke SendMessage,hImageTestL,STM_SETIMAGE,IMAGE_BITMAP,hBitmap

mov eax,TRUE
ret

   xor eax,eax
   ret
         
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	xor eax,eax
	ret
WndProc endp


end start
